IdentifiantMot de passe
Loading...
Mot de passe oublié ?Je m'inscris ! (gratuit)
Navigation

Inscrivez-vous gratuitement
pour pouvoir participer, suivre les réponses en temps réel, voter pour les messages, poser vos propres questions et recevoir la newsletter

Lisp Discussion :

Calcul de surface avec hachure de la couleur de la polyligne


Sujet :

Lisp

  1. #1
    Nouveau Candidat au Club
    Homme Profil pro
    geomètre
    Inscrit en
    janvier 2023
    Messages
    1
    Détails du profil
    Informations personnelles :
    Sexe : Homme
    Âge : 50
    Localisation : France, Paris (Île de France)

    Informations professionnelles :
    Activité : geomètre
    Secteur : Bâtiment

    Informations forums :
    Inscription : janvier 2023
    Messages : 1
    Points : 1
    Points
    1
    Par défaut Calcul de surface avec hachure de la couleur de la polyligne
    Un ancien collègue m'a fourni le lisp en pièce jointe.

    Celui-ci a pour but, un calcul de surface de polylignes, inscrire la surface, mettre une hachure de la couleur du calque dans les polylignes.
    Il crée deux calques "le nom du calque-TXT" pour la surface et "le nom du calque - Hach) pour la hachure.

    Le souci est que les hachures ne se mettent pas de la bonne couleur (celle de la polyligne) (cf : la capture d'écran).

    Ma connaissance en lisp étant très limité (plus du bidouillage).

    Pourriez-vous me venir en aide pour solutionner ce problème.

    Vous remerciant de votre aide.
    FAFAMRX

    Le LISP:
    (defun c:+coulcalk ()
    (setq coulini (getvar 'cecolor))
    (setq accroini (getvar 'osmode))
    (setq calkini (getvar 'clayer))
    (setq inserUini (getvar 'insunits))
    (setq inserUDefSini (getvar 'insunitsdefsource))
    (setq inserUDefTini (getvar 'insunitsdeftarget))
    (command "scu" "")
    (setvar "cmddia" 0)
    (setvar 'osmode 16416)
    (setvar 'cecolor "BYLAYER")
    (setvar 'insunits 6)
    (setvar 'insunitsdefsource 6)
    (setvar 'insunitsdeftarget 6)
    (setvar 'angbase 0)
    (setq nerr 0)
    (setq total 0)
    (setq ct 0)
    (setq par1 0)
    (setq listcalk nil)
    (setq listsurf '())
    (if (= (getvar 'aunits) 2)
    (setq koef 200)
    (setq koef 180)
    )
    (if ( = (getvar 'angdir) 1)
    (setq
    rot (/ (* koef (getvar 'viewtwist) ) pi) ; rotation de la vue exprimée dans l'unité d'angle du dessin
    )
    (setq
    rot (/ (* koef (- 0.0 (getvar 'viewtwist))) pi) ; rotation de la vue exprimée dans l'unité d'angle du dessin
    )
    )
    (princ "\Selection des surfaces à additionner")
    (setq ss1 (ssget '((0 . "TEXT"))))
    (repeat (sslength ss1)
    (setq nom_ent (ssname ss1 ct))
    (setq ent1 (entget nom_ent))
    (setq d1 (assoc 1 ent1))
    (setq cd1 (cdr d1))
    (while (= "- " (substr cd1 1 2))
    (setq cd1 (strcat "-" (substr cd1 3)))
    ; retire les espaces entre le- et les chiffres
    )
    (setq par (read cd1)) ; retourne les chiffres
    (if (and (< (ascii (cdr d1)) 58) (< 44 (ascii (cdr d1))))
    (progn
    (setq coul (cdr (assoc 62 ent1)))
    (setq calk (cdr (assoc 8 ent1)))
    (if (null coul)
    (setq coul 256)
    )
    (setq total (+ total par))
    (if (assoc calk listsurf)
    (if (assoc coul (cdr (assoc calk listsurf)))
    (setq listsurf
    (subst
    (cons
    calk
    (subst
    (cons
    coul
    (+ par
    (cdr (assoc coul
    (cdr (assoc calk listsurf))
    )
    )
    )
    )
    (assoc coul (cdr (assoc calk listsurf)))
    (cdr (assoc calk listsurf))
    )
    )
    (assoc calk listsurf)
    listsurf
    )
    )
    (setq
    listsurf (subst (cons calk
    (cons (cons coul par)
    (cdr (assoc calk listsurf))
    )
    )
    (assoc calk listsurf)
    listsurf
    )
    )
    )
    (progn
    (setq listsurf (cons (cons calk (list (cons coul par)))
    listsurf
    )
    )
    (setq listcalk (cons calk listcalk))
    )
    )
    )
    (setq nerr (1+ nerr))
    )
    (setq ct (+ 1 ct))
    )
    (if (/= 0 nerr)
    (alert
    (strcat "\n" (rtos nerr 2 0) " texte(s) non numérique(s) non pris en compte")
    )
    )
    (princ "\nRésultat de l'addition : ")
    (princ total)

    (setq listcalk (acad_strlsort listcalk))
    (if ( = (getvar 'angdir) 1)
    (setq angtxt (angtof (rtos (+ (/ koef 2) rot)) (getvar 'aunits)))
    (setq angtxt (angtof (rtos (- rot (/ koef 2))) (getvar 'aunits)))
    )
    (setq pt (getpoint "\n Point d'insertion du texte ? "))
    (setq TS (getvar 'TEXTSTYLE))
    (setq totaltext (strcat "Total général= " (rtos total) " m2"))
    (command "_text" "_s" TS "_j" "_m" pt rot totaltext)
    (while (<= 1 (length listcalk))
    (setq StotK 0.0)
    (setvar 'cecolor "BYLAYER")
    (setvar 'clayer (car listcalk))
    (setq pt (polar pt angtxt 1))
    (command "_text"
    "_s"
    "surface"
    "_j"
    "_m"
    pt
    rot
    (car listcalk)
    )
    (if (assoc 256 (cdr (assoc (car listcalk) listsurf)))
    (progn
    (setq pt (polar pt angtxt 1))
    (setq totaltext
    (strcat
    "Total DUCALQUE = "
    (rtos
    (cdr (assoc 256
    (cdr (assoc (car listcalk) listsurf))
    )
    )
    )
    " m2"
    )
    )
    (command "_text" "_s" "surface" "_j" "_m" pt rot totaltext)
    (setq StotK
    (+ StotK
    (cdr (assoc 256 (cdr (assoc (car listcalk) listsurf)))
    )
    )
    )
    )
    )
    (setq ct 0)
    (while (<= ct 255)
    (if (assoc ct (cdr (assoc (car listcalk) listsurf)))
    (progn
    (setvar 'cecolor (rtos ct 2 0))
    (setq pt (polar pt angtxt 1))
    (setq totaltext
    (strcat
    "Total couleur "
    (rtos ct 2 0)
    " = "
    (rtos
    (cdr
    (assoc ct
    (cdr (assoc (car listcalk) listsurf))
    )
    )
    )
    " m2"
    )
    )
    (command "_text" "_s" "surface" "_j" "_m" pt rot totaltext)
    (setq StotK
    (+
    StotK
    (cdr (assoc ct (cdr (assoc (car listcalk) listsurf)))
    )
    )
    )
    )
    )
    (setq ct (1+ ct))
    )
    (if (> (length (cdr (assoc (car listcalk) listsurf))) 1)
    (progn
    (setq pt (polar pt angtxt 1))
    (setq totaltext (strcat "Total des surfaces du calque "
    (car listcalk)
    " = "
    (rtos Stotk)
    " m2"
    )
    )
    (setvar 'cecolor "BYLAYER")
    (command "_text" "_s" "surface" "_j" "_m" pt rot totaltext)
    )
    )
    (setq listcalk (cdr listcalk))
    )
    (setvar 'cecolor coulini)
    (setvar 'osmode accroini)
    (setvar 'clayer calkini)
    (setvar 'cmddia 1)
    (setvar 'filedia 1)
    (setvar 'insunitsdefsource inserUDefSini)
    (setvar 'insunitsdeftarget inserUDefTini)
    (setvar 'insunits inserUini)
    (if (< (atoi (getvar "acadver")) 20)
    (command "scu" "p")
    (command-s "scu" "p")
    )
    Images attachées Images attachées  
    Fichiers attachés Fichiers attachés

  2. #2
    Membre habitué
    Inscrit en
    juin 2002
    Messages
    190
    Détails du profil
    Informations forums :
    Inscription : juin 2002
    Messages : 190
    Points : 134
    Points
    134
    Par défaut
    Bonjour,

    Regarde du coté de chez Mac: pleins d'exemples pour apprendre le lisp.
    http://www.lee-mac.com/programs.html

    Dans ton programme tu n'as pas définis, créé tes calques (= layers en Englais).
    La partie de dessin (polylines...) est aussi absente.
    Tes variables ne sont pas présentes dans la définition de ta fonction:
    (defun c:coulcalk () -> (defun c:coulcalk ( / coulini accroini calkini)...)
    n'oublie pas l'intendation:
    (if (= (getvar 'aunits) 2)
    (setq koef 200)
    (setq koef 180)
    )
    ->
    (if (= (getvar 'aunits) 2)
    (setq koef 200)
    (setq koef 180)
    )

    C'est peut-être un peu tôt mais tu peux aussi regarder comment utiliser et qu'apporte la fonction lisp (vlax-ename->vla-object entname).

    J'ai aussi commencé par du bidouillage.
    A+

Discussions similaires

  1. Sélection par couleur et calcul de surface
    Par marcooker dans le forum ImageJ
    Réponses: 8
    Dernier message: 27/12/2014, 12h49
  2. Réponses: 1
    Dernier message: 04/01/2014, 12h48
  3. calcul de surface a partir d'une photo avec image j
    Par saulyn dans le forum Imagerie
    Réponses: 0
    Dernier message: 29/11/2010, 15h54
  4. calculer une moyenne avec une requete externe
    Par allowen dans le forum Langage SQL
    Réponses: 3
    Dernier message: 27/01/2005, 17h02
  5. Taille des surfaces avec DirectDraw
    Par Shakram dans le forum DirectX
    Réponses: 5
    Dernier message: 09/09/2002, 01h42

Partager

Partager
  • Envoyer la discussion sur Viadeo
  • Envoyer la discussion sur Twitter
  • Envoyer la discussion sur Google
  • Envoyer la discussion sur Facebook
  • Envoyer la discussion sur Digg
  • Envoyer la discussion sur Delicious
  • Envoyer la discussion sur MySpace
  • Envoyer la discussion sur Yahoo